<?php
function generate_plugin($name,$template,$params = array()) {
	$pattern = '/\[\[([^\]]+)\]\[(text|textarea|hidden|select)\](\[([^\]]+)\])?\]/';

	//override content_type
	global $content_type,$edit_source;
	$content_type = 'text/plain';
	$edit_source = true;

	$fields = parse_template($template);
	
	?>
	<style>
	#new<?php echo $name; ?> {
		display:block;
		margin-left:130px;
		width: 200px;
		text-align:center;
		padding: 3px 2px;
		margin-top:5px;
		cursor:pointer;
	}
	.<?php echo $name; ?> {
		margin-top:5px;
		padding-top:5px;
		border-top:1px solid black;
	}
	.action_links_holder {
		font-size: .8em;
		margin-top:4px;
		margin-left: 10px;
	}
	</style>
	<div class='standard_form'><?php
	foreach($fields as $field) {
	?>
	<br />
	<label><?php echo ucwords($field['label']); ?>:</label><?php
		switch($field['type']) {
			case 'textarea': 
	?><textarea id='<?php echo $name; ?>_<?php echo $field['id']; ?>' rows='3'></textarea><?php break;
			case 'select':
	?><select id='<?php echo $name; ?>_<?php echo $field['id']; ?>'><?php
		foreach($field['options'] as $value=>$display) {
			echo "\n\t<option value=\"$value\">$display</option>";
		}
		echo "\n";
	?></select><?php break;
			case 'text': 
			case 'hidden':
			default: 
	?><input type='<?php echo $field['type']; ?>' id='<?php echo $name; ?>_<?php echo $field['id']; ?>' /><?php break;
		}
	}
	?>
	
	<br/><a id='new<?php echo $name; ?>' class='ui-state-default ui-button ui-corner-all'><?php echo translate('add'); ?></a>
	</div>
	
	
	<?php if(!$params['nodivs']) { ?>
	<div id='edit_dialog' style='display:none; font-size: 120%; text-align:left;'><?php
		$first = true;
		foreach($fields as $field) {
		if(!$first) echo "<br/><br/>";
		$first = false;
		?>
		<strong><?php echo ucwords($field['label']); ?></strong>:<br/><?php
			switch($field['type']) {
				case 'textarea': 
		?><textarea id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>' style='width: 100%; vertical-align:top;' rows='5'></textarea><?php break;
				case 'select':
		?><select id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>'><?php
			foreach($field['options'] as $value=>$display) {
				echo "\n\t<option value=\"$value\">$display</option>";
			}
			echo "\n";
		?></select><?php break;
				case 'text': 
				case 'hidden':
				default: 
		?><input type='<?php echo $field['type']; ?>' id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>' style='width: 100%;' /><?php break;
			}
		}
		?>
	</div>
	<?php } ?>
	
	<div id='cms_preview' style='width: 600px; border: 1px solid #888; height:350px; margin-top:20px; overflow:auto;'></div>
	<script type='text/javascript'>
		var current_edit_link = null;
		var $edit_dialog = null;
	
		$(document).ready(function() {
			//create hide/show link
			var link = $("<a>").attr('href','#').text('<?php echo translate('Show Code'); ?>').css('font-size','.7em').click(function() {
				var holder = $("#dsrte_holder");
				if(holder.css('display') == 'none') {
					holder.show().trigger('afterShow');
				}
				else {
					holder.hide();
				}
				return false;
			});
			$("#dsrte_holder").hide().before(link);
		});
		
		$("#new<?php echo $name; ?>").click(function() {
			//get inputs and trim whitespace
			var params = new Object();
			<?php foreach($fields as $field) { 
			?>params.<?php echo $field['id']; ?> = $.trim($("#<?php echo $name; ?>_<?php echo $field['id']; ?>").val());
			<?php if($field['type'] == 'textarea') {
			echo 'params.'.$field['id']; ?> = params.<?php echo $field['id']; ?>.replace(/\r\n|\n|\r/g,'<br/>');
			<?php }} ?>
			
			addNew(params);
			
			return false;
		});
		
		function addNew(params) {
			
			var display = <?php if(!$params['nodivs']) { ?>'<div class="<?php echo $name; ?>">'+ 
			<?php } echo '"'.implode("\" + \n\t\t\t\"",explode("\n",preg_replace(array('/\r\n/','/\r/',$pattern),array("\n","\n",'" + params.$1 + "'),addslashes($template)))).'"'; if(!$params['nodivs']) { ?> +
			'</div>'<?php } ?>;
			
			var curtext = $("#dsrte_text").val();
			
			//add display to end of current text
			$("#dsrte_text").val(curtext + "\n" + display).trigger('change');

			updatePreview();	
		}
		
		function updatePreview() {
			var code = $("#dsrte_text").val();
			$("#cms_preview").html(code);
			
			<?php if($params['nodivs']) {
			?>$("<?php echo $params['nodivs']; ?>",$("#cms_preview")).after('<a class="remove_link action_links_holder" href="#"><?php echo (translate('remove')); ?></a>');
			$("a.remove_link",$("#cms_preview")).click(setRemoveLinks);
			<?php } else { 
			?>
			$("div.<?php echo $name; ?>").append('<div class="action_links_holder"><a class="edit_link" href="#"><?php echo (translate('edit')); ?></a> | <a class="remove_link" href="#"><?php echo (translate('remove')); ?></a> | <a class="moveup_link" href="#"><?php echo (translate('move up')); ?></a> | <a class="movedown_link" href="#"><?php echo (translate('move down')); ?></a></div>');
			$("a.edit_link",$("#cms_preview")).click(setEditLinks);
			$("a.remove_link",$("#cms_preview")).click(setRemoveLinks);
			$("a.moveup_link",$("#cms_preview")).click(moveUp);
			$("a.movedown_link",$("#cms_preview")).click(moveDown);
			<?php } ?>
			
		}
		function setEditLinks() {
			current_edit_link = $(this);
			
			var element = $(this).closest('div.<?php echo $name; ?>');
			
		<?php
		foreach($fields as $field) {
			if(!isset($params['selectors'][$field['id']])) { ?>
			$("#edit_<?php echo $name; ?>_<?php echo $field['id']; ?>").val("");<?php
			} else { ?>
			$("#edit_<?php echo $name; ?>_<?php echo $field['id']; ?>").val($("<?php echo $params['selectors'][$field['id']]; ?>",element).text());<?php 
			}
		}
		?>
			
			$edit_dialog.dialog('open');
			
			return false;
		}
		function setRemoveLinks() {
			//remove target p
			<?php if($params['nodivs']) {
			?>$(this).prev("<?php echo $params['nodivs']; ?>").remove();
			<?php } else { 
			?>$(this).closest('div.<?php echo $name; ?>').remove();
			<?php } ?>
		
			//remove all action links
			$('.action_links_holder',$("#cms_preview")).remove();
			
			//set value
			$("#dsrte_text").val($("#cms_preview").html()).trigger('change');
			
			updatePreview();
			return false;
		}
		
		<?php if(!$params['nodivs']) { ?>
		function moveUp() {
			//get previous element
			var curr = $(this).closest('div.<?php echo $name; ?>');
			var prev = curr.prev('div.<?php echo $name; ?>');
			
			//previous element exists
			if(prev.length == 1) {
				//insert current element before previous
				curr.insertBefore(prev);
			
				//remove all action links
				$('.action_links_holder',$("#cms_preview")).remove();
				
				//set value
				$("#dsrte_text").val($("#cms_preview").html()).trigger('change');
				
				updatePreview();
			}
			
			return false;
		}
		function moveDown() {
			//get next element
			var curr = $(this).closest('div.<?php echo $name; ?>');
			var next = curr.next('div.<?php echo $name; ?>');
			
			//next element exists
			if(next.length == 1) {
				//insert current element after next
				curr.insertAfter(next);
			
				//remove all action links
				$('.action_links_holder',$("#cms_preview")).remove();
				
				//set value
				$("#dsrte_text").val($("#cms_preview").html()).trigger('change');
				
				updatePreview();
			}
			
			return false;
		}
		
		$(document).ready(function() {
			$edit_dialog = $("#edit_dialog").dialog({
				autoOpen:false, 
				title:"<?php echo translate('edit'); ?> <?php echo ucwords($name); ?>", 
				modal:true, 
				width: '500px',
				buttons:[
					{text: "<?php echo translate('edit'); ?>", click: function() {
						if(current_edit_link == null) {
							$(this).dialog('close');
							return;
						}
					
						var element = current_edit_link.closest("div.<?php echo $name; ?>");
							
						current_edit_link= null;
							
						var params = new Object();
						<?php foreach($fields as $field) { 
						?>params.<?php echo $field['id']; ?> = $.trim($("#edit_<?php echo $name; ?>_<?php echo $field['id']; ?>").val());
						<?php if($field['type'] == 'textarea') {
						echo 'params.'.$field['id']; ?> = params.<?php echo $field['id']; ?>.replace(/\r\n|\n|\r/g,'<br/>');
						<?php }} ?>
						
						var display = <?php echo '"'.implode("\" + \n\t\t\t\"",explode("\n",preg_replace(array('/\r\n/','/\r/',$pattern),array("\n","\n",'" + params.$1 + "'),addslashes($template)))).'"'; ?>;
						
						//update element with new data
						element.html(display);
			
						//remove all action links
						$('.action_links_holder',$("#cms_preview")).remove();
						
						//set value
						$("#dsrte_text").val($("#cms_preview").html()).trigger('change');
						
						updatePreview();
						
						$(this).dialog('close');
					}},
					{text: "<?php echo translate('Cancel'); ?>", click: function() { $(this).dialog("close"); }},
				]
			});
		<?php } else { ?>
		$(document).ready(function() {
		<?php } 
		
		//editable select elements
		if($params['editable']) {
			foreach($params['editable'] as $editable) {
				//not a select field
				if($fields[$editable]['type'] != 'select') continue;
				
				echo "\n\t\t\t$('#{$name}_{$editable}, #edit_{$name}_{$editable}').simpleCombo();";
			}
		}
		?>
		
		});
		updatePreview();
	</script>
	<?php
}

//csv plugin generator
function generate_csv_plugin($name,$params = array()) {
	$pattern = '/\[\[([^\]]+)\]\[(text|textarea|hidden|select)\](\[([^\]]+)\])?\]/';
	
	//override content_type
	global $content_type,$edit_source,$js_files;
	addToArray($js_files,'json-to-csv');
	$content_type = 'text/plain';
	$edit_source = true;

	$fields = $params['fields'];
	
	//flesh out any select fields to include both value and display for each option
	foreach($fields as $k=>$field) {
		if($field['type'] == 'select' && isset($field['options'][0])) {
			$options = array();
			foreach($field['options'] as $key=>$o) {
				if(is_numeric($key)) $options[$o] = $o;
				else $options[$key] = $o;
			}
			$fields[$k]['options'] = $options;
		}
	}
	
	if($params['format_function']) $format_function = $params['format_function'];
	else $format_function = 'format_'.$name;
	?>
	<style>
	.standard_form label {
		display:block;
		float:left;
		width: 120px;
		font-weight:bold;
		padding-top:3px;
		text-align:right;
	}
	.standard_form input, .standard_form select, .standard_form textarea {
		margin-left:10px;
		margin-top:3px;
		padding: 2px;
	}
	.standard_form input {
		width: 200px;
	}
	.standard_form textarea {
		width: 400px;
	}
	#new<?php echo $name; ?> {
		display:block;
		margin-left:130px;
		width: 200px;
		text-align:center;
		padding: 3px 2px;
		margin-top:5px;
		cursor:pointer;
	}
	.<?php echo $name; ?> {
		margin-top:5px;
		padding-top:5px;
		border-top:1px solid black;
	}
	.action_links_holder {
		font-size: .8em;
		margin-top:4px;
		margin-left: 10px;
	}
	</style>
	<div class='standard_form'><?php
	foreach($fields as $key=>$field) {
	?>
	<br />
	<?php if($field['description']) echo "<p>".$field['description']."</p>"; ?>
	<label><?php echo ucwords($field['label']); ?>:</label><?php
		switch($field['type']) {
			case 'textarea': 
	?><textarea id='<?php echo $name; ?>_<?php echo $field['id']; ?>' rows='3'></textarea><?php break;
			case 'select':
	?><select id='<?php echo $name; ?>_<?php echo $field['id']; ?>'><?php
		foreach($field['options'] as $value=>$display) {
			echo "\n\t<option value=\"$value\">$display</option>";
		}
		echo "\n";
	?></select><?php break;
			case 'text': 
			case 'hidden':
			default: 
	?><input type='<?php echo $field['type']; ?>' id='<?php echo $name; ?>_<?php echo $field['id']; ?>' /><?php break;
		}
	}
	?>
	
	<br/><a id='new<?php echo $name; ?>' class='ui-state-default ui-button ui-corner-all'><?php echo translate('add'); ?></a>
	</div>
	
	
	<?php if(!$params['nodivs']) { ?>
	<div id='edit_dialog' style='display:none; font-size: 120%; text-align:left;'><?php
		$first = true;
		foreach($fields as $field) {
		if(!$first) echo "<br/><br/>";
		$first = false;
		?>
		<strong><?php echo ucwords($field['label']); ?></strong>:<br/><?php
			switch($field['type']) {
				case 'textarea': 
		?><textarea id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>' style='width: 100%; vertical-align:top;' rows='5'></textarea><?php break;
				case 'select':
		?><select id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>'><?php
			foreach($field['options'] as $value=>$display) {
				echo "\n\t<option value=\"$value\">$display</option>";
			}
			echo "\n";
		?></select><?php break;
				case 'text': 
				case 'hidden':
				default: 
		?><input type='<?php echo $field['type']; ?>' id='edit_<?php echo $name; ?>_<?php echo $field['id']; ?>' style='width: 100%;' /><?php break;
			}
		}
		?>
	</div>
	<?php } ?>
	
	<div id='cms_preview' style='width: 600px; border: 1px solid #888; height:350px; margin-top:20px; overflow:auto;'></div>
	<script type='text/javascript'>
		var $edit_dialog = null;
		var current_formatted_element = null;
		var current_source_row = 0;
	
		$(document).ready(function() {
			//create hide/show link
			var link = $("<a>").attr('href','#').text('<?php echo translate('Show Code'); ?>').css('font-size','.7em').click(function() {
				var holder = $("#dsrte_holder");
				if(holder.css('display') == 'none') {
					holder.show().trigger('afterShow');
				}
				else {
					holder.hide();
				}
				return false;
			});
			$("#dsrte_holder").hide().before(link);
		});
		
		$("#new<?php echo $name; ?>").click(function() {
			//get inputs and trim whitespace/newlines
			var values = [];
			<?php $i = 0; foreach($fields as $field) { 
			?>values[<?php echo $i; ?>] = $.trim($("#<?php echo $name; ?>_<?php echo $field['id']; ?>").val()).replace(/\r\n|\n|\r/g,'<br/>');
			<?php $i++;
			} ?>
			addNew(values);
			
			return false;
		});
		
		function addNew(values) {
			var display = arr_to_csv(values);
			var curtext = $.trim($("#dsrte_text").val());
			
			if(curtext.length >0) curtext += "\n";
			//add display to end of current text
			$("#dsrte_text").val(curtext + display).trigger('change');

			updatePreview();	
		}
		
		function updatePreview() {
			var rows = $.trim($("#dsrte_text").val());
			var rows = rows.split("\n");
			
			//no rows
			if(rows.length == 0 || (rows.length == 1 && rows[0].length < 2)) {
				$("#cms_preview").html("");
				return;
			}
		
			var code = "";
			var temp = "";
			
			//call format function on each row
			for(var i=0;i<rows.length;i++) {			
				//get formatted html
				temp = <?php echo $format_function; ?>(csv_to_arr(rows[i]));
				
				//wrap in div with row id and add to code
				code += "<div class='<?php echo $name; ?>' id='cmsrow_"+i+"'>"+temp+"</div>";
			}
			
			$("#cms_preview").html(code);
			
			$("div.<?php echo $name; ?>").append('<div class="action_links_holder"><a class="edit_link" href="#"><?php echo (translate('edit')); ?></a> | <a class="remove_link" href="#"><?php echo (translate('remove')); ?></a> | <a class="moveup_link" href="#"><?php echo (translate('move up')); ?></a> | <a class="movedown_link" href="#"><?php echo (translate('move down')); ?></a></div>');
			
			$("a.edit_link",$("#cms_preview")).click(setEditLinks);
			$("a.remove_link",$("#cms_preview")).click(setRemoveLinks);
			$("a.moveup_link",$("#cms_preview")).click(moveUp);
			$("a.movedown_link",$("#cms_preview")).click(moveDown);
			
			$("#cms_preview").trigger('update');
			
		}
		function setEditLinks() {
			current_formatted_element = $(this).closest('div.<?php echo $name; ?>');
			current_source_row = current_formatted_element.attr('id').split('_')[1]*1;
			
			var row = csv_to_arr($("#dsrte_text").val().split("\n")[current_source_row]);
			
		<?php
		$i = 0;
		foreach($fields as $field) { ?>
			$("#edit_<?php echo $name; ?>_<?php echo $field['id']; ?>").val(row[<?php echo $i; ?>]);
		<?php
		$i ++; }
		?>
			
			$edit_dialog.dialog('open');
			
			return false;
		}
		function setRemoveLinks() {
			//get row number
			var row = $(this).closest("div.<?php echo $name; ?>").attr('id').split('_')[1]*1;
			var rows = $.trim($("#dsrte_text").val()).split("\n");
			
			//remove row
			rows.splice(row,1);
			
			//set text
			$("#dsrte_text").val(rows.join("\n"));
			
			updatePreview();
			return false;
		}
		
		<?php if(!$params['nodivs']) { ?>
		function moveUp() {
			//get row number
			var row = $(this).closest("div.<?php echo $name; ?>").attr('id').split('_')[1]*1;
			var rows = $.trim($("#dsrte_text").val()).split("\n");
			
			move_arr_element(rows,row,-1);
			
			$("#dsrte_text").val(rows.join("\n"));
			
			updatePreview();
			
			return false;
		}
		function moveDown() {
			//get row number
			var row = $(this).closest("div.<?php echo $name; ?>").attr('id').split('_')[1]*1;
			var rows = $.trim($("#dsrte_text").val()).split("\n");
			
			move_arr_element(rows,row,1);
			
			$("#dsrte_text").val(rows.join("\n"));
			
			updatePreview();
			
			return false;
		}
		
		$(document).ready(function() {
			$edit_dialog = $("#edit_dialog").dialog({
				autoOpen:false, 
				title:"<?php echo translate('edit'); ?> <?php echo ucwords($name); ?>", 
				modal:true, 
				width: '500px',
				buttons:[
					{text: "<?php echo translate('edit'); ?>", click: function() {
						if(current_formatted_element == null) {
							$(this).dialog('close');
							return;
						}
						var element = current_formatted_element;
						current_formatted_element = null;
							
						var values = [];
						<?php $i = 0; foreach($fields as $field) { 
						?>values[<?php echo $i; ?>] = $.trim($("#edit_<?php echo $name; ?>_<?php echo $field['id']; ?>").val()).replace(/\r\n|\n|\r/g,'<br/>');
						<?php $i++;
						} ?>
						
						var display = arr_to_csv(values);
						var curtext = $.trim($("#dsrte_text").val()).split("\n");
						
						curtext[current_source_row] = display;
						
						$("#dsrte_text").val(curtext.join("\n"));
						
						updatePreview();
						
						$(this).dialog('close');
					}},
					{text: "<?php echo translate('Cancel'); ?>", click: function() { $(this).dialog("close"); }},
				]
			});
		<?php } else { ?>
		$(document).ready(function() {
		<?php } 
		
		//editable select elements
		if($params['editable']) {
			foreach($params['editable'] as $editable) {
				//not a select field
				if($fields[$editable]['type'] != 'select') continue;
				
				echo "\n\t\t\t$('#{$name}_{$editable}, #edit_{$name}_{$editable}').simpleCombo();";
			}
		}
		?>
		
		});
		updatePreview();
	</script>
	
	
	
	<?php
	
}


function parse_template($template,$pattern = '/\[\[([^\]]+)\]\[(text|textarea|hidden|select)\](\[([^\]]+)\])?\]/') {
	//parse template and pick out editable segments
	$matches = array();
	preg_match_all($pattern,$template,$matches,PREG_SET_ORDER);
	
	//make list of plugin fields
	$fields = array();
	foreach($matches as $val) {	
		if(empty($val)) continue;
		
		$label = str_replace('_',' ',$val[1]);
		$fields[$val[1]] = array(
			'label'=>$label,
			'id'=>$val[1],
			'type'=>$val[2]
		);
		if(isset($val[4])) $fields[$val[1]]['options'] = parse_select_field($val[4]);
	}
	
	return $fields;
}
function generate_field($name,$type) {
	return '[['.$name.']['.$type.']]';
}
function generate_select_field($name,$options) {
	$option_array = array();
	foreach($options as $value=>$display) {
		if(is_numeric($value)) $value = $display;
		if(empty($value) || empty($display)) continue;
		$option_array[] = $value."|".$display;
	}
	return '[['.$name.'][select]['.implode('||',$option_array).']]';
}
function parse_select_field($text) {
	$temp = explode("||",$text);
	$options = array();
	foreach($temp as $option) {
		list($value,$display) = explode("|",$option);
		$options[$value] = $display;
	}
	return $options;
}
?>