<?php
//set template level
global $template_level;
if(!isset($template_level)) $template_level = 'html';

global $nojs,$nojqueryui;

//Create list of css and js files to include
if(!isset($css_files))
	$css_files = array();
if(!isset($js_files))
	$js_files = array();
if(!isset($modules))
	$modules = array();
		
//jquery ui
global $jquery_theme_set;
if(!$nojqueryui && !$jquery_theme_set) {
	if($temp = CMS::load('site_variables','jqueryui')) {
		array_unshift($css_files,$temp);
	}
}
	
//Get css and javascripts files for modules
addToArray($css_files,$modules);
addToArray($js_files,$modules);

//add jquery base to front of array
array_unshift($js_files,"jquery-1.4.4.min");

//remove duplicates
$js_files = array_unique($js_files);
$css_files = array_unique($css_files);

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title><?php echo $title_prepend . "$title"; ?></title>
	<?php
	if(!$meta['content-type']) $meta['content-type'] = 'text/html;charset=utf-8';
	
	if($meta['description']) echo "\n".'<meta name="description" content="'.addslashes($meta['description']).'" />';
	if($meta['content-type']) echo "\n".'<meta http-equiv="Content-Type" content="'.addslashes($meta['content-type']).'" />';
	
	global $metatags;
	if($metatags) echo $metatags;
	
	//load css files first to avoid unstyled flash of content
	if($css_files) {
		echo "\n\t<link type='text/css' rel='stylesheet' href='{$site_root}css/css/".arraytourl($css_files).$extra_css_url."/?v=".file_get_contents(SITE_FOLDER.'css/version.php')."' />";
	}
	
if(!$nojs) {
	?>
	
	<script type='text/javascript'>
		//set site variables
		var site = {
			linkpref: '<?php echo $linkpref; ?>',
			site_root: '<?php echo $site_root; ?>',
			path: '<?php echo $path; ?>',
			current_path: '<?php echo $current_path; ?>'
		}
	</script>
<?php 
}
global $form_errors, $style;

//if previewing stylesheet
$extra_css_url = '';
if($_SESSION['cms_logged_in'] && $_REQUEST['preview'] && $_REQUEST['page']=='style_sheets') {
	if(in_array($_REQUEST['element'],$css_files)) {
		$extra_css_url = "&preview=true&element=$_REQUEST[element]&revision=$_REQUEST[revision]";
		//passing data to css
		if(!$_REQUEST['revision']) {
			$_SESSION['temp_css_data'] = urldecode($_REQUEST['data']);
		}
	}	
}

if(!$nojs && $js_files) {
	echo "\n\t<script type='text/javascript' src='{$site_root}js/javascript/".arraytourl($js_files)."/?v=".file_get_contents(SITE_FOLDER.'js/version.php')."'></script>";
}

if(!$nojs && !DEBUG_LEVEL && file_exists('install.php') && !$_REQUEST['preview']) {
	?>
	<script type='text/javascript'>
	$(document).ready(function() {
		alert("Please delete the install.php file");
	});
	</script>
	<?
}

if($style)	echo "<style type='text/css'>$style</style>";
?>
</head>
<body>