<?php
session_start();

//form submitted
if($_REQUEST['submit']) {
	$errors = array();

	//edit .htaccess
	$rewritebase = $_REQUEST['rewrite_base'];
	$commands = $_REQUEST['htaccess_commands'];
	$htaccess = file_get_contents('.htaccess');
	$htaccess = preg_replace('/RewriteBase [^\s]+/','RewriteBase '.$rewritebase,$htaccess);
	
	if(!is_writable('.htaccess')) {
		$temp = fileperms('.htaccess');
		chmod('.htaccess',0777);
	}
	else $temp = false;
	
	if(!file_put_contents('.htaccess',trim($htaccess ."\n". $commands))) {
		$errors[] = "Failed to edit .htaccess file.  You must do this manually.";
	}
	
	if($temp) chmod('.htaccess',$temp);
	
	//edit server/server.php
	$site_root = $_REQUEST['site_root'];
	$domain = $_REQUEST['domain'];
	$from_email = $_REQUEST['from_email'];
	$to_email = $_REQUEST['to_email'];
	$email_type = $_REQUEST['email_type'];
	
	$server = file_get_contents('server/server.php');
	$server = preg_replace('/\$site_root = \'[^\']+\';/','$site_root = \''.$site_root.'\';',$server);
	$server = preg_replace('/define\(\'DOMAIN\',\'[^\']+\'\);/','define(\'DOMAIN\',\''.$domain.'\');',$server);
	$server = preg_replace('/define\(\'FROM_EMAIL\',\'[^\']*\'\);/','define(\'FROM_EMAIL\',\''.$from_email.'\');',$server);
	$server = preg_replace('/define\(\'TO_EMAIL\',\'[^\']*\'\);/','define(\'TO_EMAIL\',\''.$to_email.'\');',$server);
	
	if($email_type == 'sendmail') {
		$email_settings = 'array(
	\'type\'=>\'sendmail\',
	\'command\'=>\''.$_REQUEST['sendmail_command'].'\'
)';
	}
	elseif($email_type == 'SMTP') {
		$email_settings = 'array(
	\'type\'=>\'smtp\',
	\'host\'=>\''.$_REQUEST['smtp_host'].'\',
	\'port\'=>\''.$_REQUEST['smtp_port'].'\',
	\'username\'=>\''.$_REQUEST['smtp_username'].'\',
	\'password\'=>\''.$_REQUEST['smtp_password'].'\',
)';
	}
	else {
		$email_settings = 'array(
	\'type\'=>\'mail\'
)';
	}
	
	$server = preg_replace('/\$email_settings = array\([^)]+\);/','$email_settings = '.$email_settings.';',$server);
	
	if(!is_writable('server/server.php')) {
		$temp = fileperms('server/server.php');
		chmod('server/server.php',0777);
	}
	else $temp = false;
	
	if(!file_put_contents('server/server.php',$server)) {
		$errors[] = "Failed to edit server/server.php.  You must do this manually.";
	}
	
	if($temp) chmod('server/server.php',$temp);
	
	//set file permissions for writable directories
	$writable = array(
		'files/',
		'uploadedimages/',
		'backups/',
		'site/cms/page_content/',
		'site/cms/page_descriptions/',
		'site/cms/pages/',
		'site/cms/revisions/'
	);
	foreach($writable as $dir) {
		if(!is_writable($dir)) {
			if(!chmodr($dir,0777)) {
				$errors[] = "Failed to make $dir writable.  You must do this manually.";
			}
		}
	}
	
	
	if(!$errors) {
		echo "<p>If the homepage below looks correct, the installation worked.</p>  <p>If you see a Server 500 error below, you have an invalid htaccess command and must fix this manually by editing .htaccess on the server.</p>  
		<p>Most other errors you can fix by <a href='install.php'>running the installation again</a>.</p>
		<p>Make sure to delete this file as soon as possible.  <a href='{$site_root}home/'>Visit the home page</a>.</p>";
		
		echo "<iframe style='border: 1px solid black; overflow:auto; width: 800px; height: 450px; margin: 20px;' src='{$site_root}home/?preview=true'></iframe>";
		
		exit();
	}
	else {
		foreach($errors as $error) {
			echo "<p style='color:red;'>$error</p>";
		}
	}
}

//current path: /mysite/install.php
$current_path = $_SERVER['REQUEST_URI'];

$site_root = '/'.trim(dirname($current_path),'/\\');
if(strlen($site_root) !== 1) $site_root .= '/';
$htaccess = '/'.trim($site_root,'/');
$domain = (empty($_SERVER['HTTPS'])? 'http' : 'https') . '://' . $_SERVER['HTTP_HOST'].'/';

$top_domain = explode('.',$_SERVER['HTTP_HOST']);
if(count($top_domain) >= 2) {
	$top_domain = array_pop($top_domain) . '.' . array_pop($top_domain);
}
else $top_domain = implode('.',$top_domain);

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>Install DornCMS</title>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js"></script>
	<style>
		* {
			font-family: arial, sans serif;
		}
		form {
			border: 1px solid #999999;
			padding: 20px;
		}
		label {
			font-weight:bold;
			vertical-align: top;
		}
		form p {
			font-weight: .8em;
			padding:0;
			margin: 5px 0 25px 10px;
		}
	</style>
	<script>
	$(document).ready(function() {
		function setMailOptions() {
			var type = $("form select[name=\"email_type\"]").val();
			
			if(type=='mail') {
				$("#sendmail_options").hide();
				$("#smtp_options").hide();
			}
			else if(type=='sendmail') {
				$("#smtp_options").hide();
				$("#sendmail_options").show();
			}
			else {
				$("#sendmail_options").hide();
				$("#smtp_options").show();
			}
		}
		$("form select[name=\"email_type\"]").change(setMailOptions).trigger('change');
		
	});
	</script>
</head>
<body>
	<h1>Install DornCMS</h1>
	<p>This will install DornCMS on this server.  Make sure you delete this file once the site is installed.</p>
	<form method='post' action='?'>
		<label>Site Root:</label> <input type='text' name='site_root' value='<?php echo $site_root; ?>' /><br/>
		<p>This is the directory you installed the site in relative to your document root.  If you are installing this in the root directory, set $site_root to '/'.</p>
		
		<label>RewriteBase:</label> <input type='text' name='rewrite_base' value='<?php echo $htaccess; ?>' />
		<p>This is what RewriteBase will be set to in the .htaccess file.  On most servers, this is equal to $site_root without the trailing slash.</p>
		
		<label>.htaccess Commands:</label> <textarea name='htaccess_commands'></textarea>
		<p>Here, you can put any additional commands for the .htaccess file.  On most setups, you can leave this blank, but some servers require extra code to work.  For example, 1and1 hosting uses PHP4 by default and you must force it to use PHP5 with the line "AddType x-mapp-php5 .php".</p>
		
		<label>Domain:</label> <input type='text' name='domain' value='<?php echo $domain; ?>' />
		<p>This is the domain the site is accessed from.  This is used to provide a link back to the site in outgoing emails.</p>
		
		<label>From Email:</label> <input type='text' name='from_email' value='from@<?php echo $top_domain; ?>' />
		<p>This is used as the From address in outgoing email.</p>
		
		<label>To Email:</label> <input type='text' name='to_email' value='to@<?php echo $top_domain; ?>' />
		<p>This is where outgoing email is sent to.  When forms are submitted on the site, the responses are emailed here.</p>
		
		<label>Mail Server Type:</label> <select name='email_type'><option value='mail'>PHP mail() function</option><option value='SMTP'>SMTP server</option><option value='sendmail'>Sendmail</option></select>
		<p>How outgoing emails are sent from the site.</p>
		
		<div id='sendmail_options'>
			<label>Sendmail Command:</label> <input type='text' name='sendmail_command' value="/usr/sbin/sendmail -bs" />
			<p>The shell command of the sendmail script.  The default is "/usr/sbin/sendmail -bs".</p>
		</div>
		<div id='smtp_options'>
			<label>SMTP Host:</label> <input type='text' name='smtp_host' />
			<p>Ex: smtp.example.com</p>
			
			<label>SMTP Port:</label> <input type='text' name='smtp_port' value='25' />
			<p>(defaults to 25)</p>
			
			<label>SMTP Username:</label> <input type='text' name='smtp_username' />
			<p></p>
			
			<label>SMTP Password:</label> <input type='text' name='smtp_password' />
			<p></p>
		</div>
		<input type='submit' value='Submit' name='submit' />
	</form>
	
	
</body>
</html>
<?php
function chmodr($path, $filemode) {
    if (!is_dir($path))
        return chmod($path, $filemode);

    $dh = opendir($path);
    while (($file = readdir($dh)) !== false) {
        if($file != '.' && $file != '..') {
            $fullpath = $path.'/'.$file;
            if(is_link($fullpath))
                return FALSE;
            elseif(!is_dir($fullpath) && !chmod($fullpath, $filemode))
                    return FALSE;
            elseif(!chmodr($fullpath, $filemode))
                return FALSE;
        }
    }

    closedir($dh);

    if(chmod($path, $filemode))
        return TRUE;
    else
        return FALSE;
}
?>