<?php
cmsLogin();

//plugin helper functions
include "includes/plugins.php";

$js_files = $css_files = array();

$page = $_REQUEST['page'];
$element = $_REQUEST['element'];

$edit_element = !empty($element);

//if trying to edit style_sheets page or site_variables page, redirect to choose element
if(!$edit_element && in_array($page,array('style_sheets','site_variables'))) {
	header("Location: {$site_root}cms/edit/$page");
	exit();
}

//if not allowed to edit page, go to choose elements page
if((!$_REQUEST['edit_description'] && !$edit_element && ($acl['noeditpages'] || (isset($acl['pages'][$page]) && $acl['pages'][$page] === 0)))) {
	header("Location: {$site_root}cms/edit/$page/");
	exit();
}
//if not allowed to edit element, go to choose elements page
elseif(!$_REQUEST['edit_description'] && ((isset($acl['elements'][$page]) && $acl['elements'][$page] === 0) || (isset($acl['elements'][$page][$element]) && $acl['elements'][$page][$element] === 0))) {
	header("Location: {$site_root}cms/edit/$page/");
	exit();
}

$style = "
	#preview_target {
		width: 90%;
		margin: 15px 5%;
		height: 600px;
	}
	#preview_holder {
		position:absolute;
		width: 90%;
		margin: 15px 5%;
		border: 2px solid red;
		display:none;
		background-color:white;
		top:0px;
		left:0px;
		text-align:right;
	}
	#preview_close {
		margin-right: 20px;
		line-height: 30px;
		font-weight:bold;
	}
	.CodeMirror {
		border: 1px solid black;
	}
	.preview_links a {
		margin-right: 20px;
	}
";

//list of pages that can be previewed directly
$pages = glob(SITE_FOLDER.'cms/pages/*.php');
foreach($pages as &$val) {
	$val = basename($val,'.php');
}
$site_page = $pages;

if($page != 'header' && $page != 'style_sheets' && $page != 'footer') $preview_url = $site_root.$page;
else $preview_url = $site_root.'home';

if($_REQUEST['edit_description']) $file = SITE_FOLDER."cms/page_descriptions/$page/$element.php";
elseif(!$edit_element) $file = SITE_FOLDER."cms/pages/$page.php";
else $file = SITE_FOLDER."cms/page_content/$page/$element.php";

if(!file_exists($file)) {
	exit(translate('file not found')." - $file");
}

//if form was submitted, put new content
if($_POST['submit']) {
	//decode text
	$content = $_POST['dsrte_text'];
	
	//change current file to new file
	file_put_contents($file,$content);
	
	$updated = true;
	$time = time();
	
	//create revision
	$username = $_SESSION['username'];
	if(!$_REQUEST['edit_description'] && $edit_element) {
		copy($file,SITE_FOLDER."cms/revisions/$page/$element/$time.$username.r");
		file_put_contents(SITE_FOLDER."cms/revisions/$page/$element/current.txt",$time);
	}
	elseif(!$_REQUEST['edit_description']) {
		copy($file,SITE_FOLDER."cms/revisions/$page/$time.$username.r");
		file_put_contents(SITE_FOLDER."cms/revisions/$page/current.txt",$time);
	}
	
	//if changed stylesheet, update css version
	if(!$_REQUEST['edit_description'] && $page == 'style_sheets') {
		$ver = intval(file_get_contents(SITE_FOLDER.'css/version.php')) + 1;
		file_put_contents(SITE_FOLDER.'css/version.php',$ver);
	}
	
}
//get current content of file
else {
	$content = file_get_contents($file);
}

//editing element description
if($_REQUEST['edit_description']) {
	$content_type = 'text/html';
	//edit source by default
	$_REQUEST['edit_source'] = true;
	$elements_folder = SITE_FOLDER.'cms/page_descriptions/'.$page.'/*.php';
}
//editing page
elseif(!$edit_element) {
	$content_type = 'text/php';
	$elements_folder = SITE_FOLDER.'cms/page_content/'.$page.'/*.php';
}
//editing element
else {
	ob_start();
	@include SITE_FOLDER."cms/page_descriptions/$page/$element.php"; 
	$description = ob_get_contents();
	$elements_folder = SITE_FOLDER.'cms/page_content/'.$page.'/*.php';
	ob_end_clean();
	
	if($page === 'style_sheets') $content_type = 'text/css';
	
	//special handling plugins
	if($special_handling && file_exists(SITE_FOLDER.'cms/plugins/'.$special_handling.'.php')) {
		ob_start();
		include SITE_FOLDER.'cms/plugins/'.$special_handling.'.php';
		$plugin_code = ob_get_contents();
		ob_end_clean();
	}
	//plugin code contained in description
	elseif($special_handling) $plugin_code = $special_handling;
	
	if($edit_source) $_REQUEST['edit_source'] = true;
}

if(!$content_type) $content_type = 'text/html';

$markitup = false;

//HTML file
if($content_type == 'text/html') {
	//edit source (use codemirror)
	if($_REQUEST['edit_source']) {
		$codemirror = true;

		addToArray($js_files,array(
			'codemirror/codemirror',
			'codemirror/xml',
			'codemirror/javascript',
			'codemirror/css',
			'codemirror/htmlmixed'
		));
		addToArray($css_files,array(
			'codemirror/codemirror',
			'codemirror/xml',
			'codemirror/javascript',
			'codemirror/css'
		));
	}
	//use CLEditor
	else {
		$cleditor = true;

		addToArray($js_files,array(
			'jquery.cleditor.min',
			'jquery.cleditor.xhtml.min'
		));
		addToArray($css_files,array(
			'cms/jquery.cleditor'
		));
	}
	
	if(!$edit_element) {}
	elseif(!$_REQUEST['edit_description']) {
		$description .= CMS::getInstructions('html');
	}
	else {
		$description .= "<p><a href='".$site_root.$current_path."'>".translate('Edit element')."</a></p>";
	}
}
//use markitup
elseif(substr($content_type,0,3)=='cms') {
	$markitup = true;
	
	addToArray($js_files,array(
		'jquery.markitup',
		'markitup/base_settings',
		'markitup/'.substr($content_type,4)
	));
	addToArray($css_files,array(
		'markitup/skin',
		'markitup/'.substr($content_type,4)
	));

	//add instructions based on type
	$description .= CMS::getInstructions(substr($content_type,4));
}
//use codemirror
elseif($content_type == 'text/css') {
	$codemirror = true;

	addToArray($js_files,array(
		'codemirror/codemirror',
		'codemirror/css'
	));
	addToArray($css_files,array(
		'codemirror/codemirror',
		'codemirror/css'
	));
	
	$description .= CMS::getInstructions('css');
}
elseif($content_type == 'text/php') {
	$codemirror = true;

	addToArray($js_files,array(
		'codemirror/codemirror',
		'codemirror/xml',
		'codemirror/javascript',
		'codemirror/css',
		'codemirror/clike',
		'codemirror/php'
	));
	addToArray($css_files,array(
		'codemirror/codemirror',
		'codemirror/xml',
		'codemirror/javascript',
		'codemirror/css',
		'codemirror/clike'
	));
}

//add additional js and css files based on description
if($markitup && $extra_buttons) {
	addToArray($js_files,'markitup/'.$extra_buttons);
	addToArray($css_files,'markitup/'.$extra_buttons);
}

//add combobox plugin
addToArray($js_files,'jquery.combobox');

//get list of possible pages
$pages = scandir(SITE_FOLDER.'cms/page_content/');

$page_options = array();
foreach ($pages as $page_name ) {
	if($page_name{0} == '.') continue;
	
	if(isset($acl['elements'][$page_name])) {
		if($acl['elements'][$page_name] === 0) {
			continue;
		}
	}
	
	$page_options[] = "<option value='$page_name' ".(($page==$page_name)? "selected='selected'" : '').">$page_name</option>";
}
$page_select = "<select id='page_select'>".implode("\n",$page_options)."</select>";

//get list of possible element on current page
$elements = glob($elements_folder);
$element_options = array();
foreach ($elements as $element_path ) {
	$element_name = basename($element_path,'.php');
	
	if(isset($acl['elements'][$page][$element_name])) {
		if($acl['elements'][$page][$element_name] === 0) continue;
	}

	$element_options[] = "<option value='$element_name' ".(($element==$element_name)? "selected='selected'" : '').">$element_name</option>";
}
if(!$edit_element) array_unshift($element_options,'<option selected="selected" value="">Choose Element</option>');
$element_select = "<select id='element_select'>".implode("\n",$element_options)."</select>";

if($edit_element)
	$title = translate('Editing')." $page &gt; $element";
else
	$title = translate('Editing')." $page";
	
$hidetitle = true;
include_header('cms_header');
?>
<script type='text/javascript'>
$(document).ready(function() {
	$("#page_select").change(function() {
		window.location.href='<?php if($edit_element) echo $site_root.'cms/edit/'; else echo $site_root.'cms/edit_page/'; ?>'+$(this).val()+'/';
	});
	$("#element_select").change(function() {
		window.location.href='<?php echo $site_root .'cms/edit/'.$page; ?>/'+$(this).val()+'/<?php echo '?'.$_SERVER['QUERY_STRING']; ?>';
	});
	
	//store original value
	var $original_text = $.trim($("#dsrte_text").val());
	$("#dsrte_text").change(function() {
		if($.trim($(this).val()) != $original_text) {
			$("#update_notice").hide();
			$("#needs_updating").show();
		}
		else {
			$("#needs_updating").hide();
		}
	});
	
	//preview page link
	$("#preview_page").click(function() {
		//remove previously created preview forms
		$("#preview_form").remove();

		//create new preview form
		var form = $("<form>").attr('id','preview_form').attr('method','post').attr('action','<?php echo $preview_url; ?>/').attr('target','preview_target')
			.css('display','none');
		
		//add element input to form
		$("<input type='text'>").attr('name','element').val('<?php echo $element; ?>').appendTo(form);
		$("<input type='text'>").attr('name','page').val('<?php echo $page; ?>').appendTo(form);
		$("<input type='text'>").attr('name','preview').val('true').appendTo(form);
		
		//add data element to form
		<?php if($codemirror) { ?>
		editor.save();
		$("#dsrte_text").trigger('change');
		<?php } ?>
		$("<textarea>").attr('name','data').val($("#dsrte_text").val()).appendTo(form);
			
		//add form to page
		form.appendTo($('body'));
		
		//submit
		form.submit();
		
		//show preview holder
		$("#preview_holder").show();
		
		return false;		
	});
	$("#preview_close").click(function() {
		$("#preview_holder").hide();
		return false;
	});

<?php
//codemirror
if($codemirror) {
	if($content_type == 'text/css') { ?>
	var editor = CodeMirror.fromTextArea($('#dsrte_text').get(0), {
		mode: "text/css"
	});
	<?php } elseif($content_type == 'text/php') { ?>
	var editor = CodeMirror.fromTextArea($('#dsrte_text').get(0), {
		lineNumbers: true,
		matchBrackets: true,
		mode: "application/x-httpd-php",
		indentUnit: 8,
		indentWithTabs: true,
		enterMode: "keep",
		tabMode: "shift"
	});
	<?php } elseif($content_type == 'text/html') { ?>
	var editor = CodeMirror.fromTextArea($('#dsrte_text').get(0), {
		mode: "text/html",
		tabMode: "indent"
	});
	<?php }
	?>
	$("#dsrte_holder").bind('afterShow',function() {
		editor.refresh();
	});
	var save_timer = setInterval(save_code,5000);
	function save_code() {
		editor.save();
		$("#dsrte_text").trigger('change');
	}
	<?php
}
elseif($cleditor) {
	?>	
	var editor = $("#dsrte_text").cleditor({
		docCSSFile: "<?php echo $site_root; ?>css/css/?files=jquery.ui%7Ccms%2Fdefault_preview%7Cbase%2Fui%7Cpreview",
		width: '100%',
		height: '350px', 
		controls:     // controls to add to the toolbar
			"bold italic underline strikethrough subscript superscript | font size " +
			"style | color highlight removeformat | bullets numbering | outdent " +
			"indent | alignleft center alignright justify | undo redo | " +
			"rule cmscontent cmssitevar cmsimage cmslink unlink | cut copy paste pastetext | print source"
	})[0];
	$("#dsrte_holder").bind('afterShow',function() {
		editor.refresh();
	});
	<?php
}
?>
});
<?php if($cleditor) { ?>
(function($) {
  $.cleditor.imagesPath = function() {
	return "<?php echo $site_root; ?>images/";
  };

  // Save the previously assigned callback handler
  var oldUpdateTextArea = $.cleditor.defaultOptions.updateTextArea;
  var oldUpdateFrame = $.cleditor.defaultOptions.updateFrame;

  // Wireup the updateTextArea callback handler
  $.cleditor.defaultOptions.updateTextArea = function(html) { 
  
	//From HTML to CMS
	
	//[url=http://google.com]Google[/url]
	html = html.replace(/<a href=['"]((http|https|ftp):\/\/[^'"]*)['"]>((.(?!<\/a>))*.)<\/a>/g,"[url=$1]$3[/url]");
	
	//[url=email@domain.com]Email[/url]
	html = html.replace(/<a href=['"]mailto:([^'"]*)['"]>((.(?!<\/a>))*.)<\/a>/g,"[url=$1]$2[/url]");
	
	//[url=pricing.pdf]download[/url]
	html = html.replace(/<a href=['"](<?php echo str_replace('/','\/',$site_root); ?>|)(files\/|)([^'"]*)['"]>((.(?!<\/a>))*.)<\/a>/g,"[url=$3]$4[/url]");
	
	//[img]file.jpg[/img]
	html = html.replace(/<img[\s]*src=['"]<?php echo str_replace('/','\/',$site_root); ?>uploadedimages\/([^'"]*)['"][\s]*(class="cms_image")?[\s]*(\/)?>/g,"[img]$1[/img]");
	
	//[cms]page - element[/cms]
	html = html.replace(/<span class=['"]cms_value cms['"]>((.(?!<\/?span>))*.)<\/span>/g,"[cms]$1[/cms]");
	
	//[sitevar]business_name[/sitevar]
	html = html.replace(/<span class=['"]cms_value sitevar['"]>((.(?!<\/?span>))*.)<\/span>/g,"[sitevar]$1[/sitevar]");
	
    // Fire the previously assigned callback handler
    if (oldUpdateTextArea)
      html = oldUpdateTextArea(html);
	
	return html;
  }
  
  $.cleditor.defaultOptions.updateFrame = function(source) {
	if(oldUpdateFrame)
		source = oldUpdateFrame(source);
		
	//From CMS to HTML
	
	//[url=http://google.com]Google[/url]
	source = source.replace(/\[url=((http|ftp|https)[^\]]*)\]([^\[]*)\[\/url\]/g,"<a href='$1'>$3</a>");
	
	//[url]http://google.com[/url]
	source = source.replace(/\[url\]((http|ftp|https)[^\[]*)\[\/url\]/g,"<a href='$1'>$1</a>");
	
	//[url=email@domain.com]Email[/url]
	source = source.replace(/\[url=(([^\]])+@([^\]])+\.([^\]])+)\]([^\[]*)\[\/url\]/g,"<a href='mailto:$1'>$5</a>");
	
	//[url]email@domain.com[/url]
	source = source.replace(/\[url\](([^\[])+@([^\[])+\.([^\[])+)\[\/url\]/g,"<a href='mailto:$1'>$1</a>");
	
	//[url=pricing.pdf]download[/url]
	source = source.replace(/\[url=([^\]]*\.[a-zA-Z0-9]+)\]([^\[]*)\[\/url\]/g,"<a href='<?php echo $site_root; ?>files/$1'>$2</a>");
	
	//[url]pricing.pdf[/url]
	source = source.replace(/\[url\]([^\[]*\.[a-zA-Z0-9]+)\[\/url\]/g,"<a href='<?php echo $site_root; ?>files/$1'>$1</a>");
	
	//[img]file.jpg[/img]
	source = source.replace(/\[img\]([^\[]*)\[\/img\]/g,'<img src="<?php echo $site_root; ?>uploadedimages/$1" class="cms_image" />');
	
	//[cms]page - element[/cms]
	source = source.replace(/\[cms\]\s*([a-zA-Z0-9\-_]+)\s*\-\s*([a-zA-Z0-9\-_]+)\s*\[\/cms\]/g,"<span class='cms_value cms'>$1 - $2</span>");
	
	//[sitevar]business_name[/sitevar]
	source = source.replace(/\[sitevar\]((.(?!\[\/sitevar]))+.)\[\/sitevar\]/g,"<span class='cms_value sitevar'>$1</span>");
	
	//[url=about/]About Us[/url]
	source = source.replace(/\[url=([^\]]*)\]([^\[]*)\[\/url\]/g,"<a href='<?php echo $site_root; ?>$1'>$2</a>");
	
	//[url]home/[/url]
	source = source.replace(/\[url\]([^\[]*)\[\/url\]/g,"<a href='<?php echo $site_root; ?>$1'>$1</a>");
	
	return source;
  }
})(jQuery);
(function($) {

  // Define the image button
  $.cleditor.buttons.cmsimage = {
    name: "cmsimage",
	stripIndex: 23,
    title: "<?php echo translate('Insert Image'); ?>",
    command: "inserthtml",
    popupName: "cmsimage",
    popupClass: "cleditorPrompt",
    popupContent:
      "<p><?php echo translate('Uploaded image'); ?>: <select>"+getImageOptions()+"</select><input type='button' value='<?php echo translate('Submit'); ?>' id='cmsimage_submit'/></p>"+
	  "<p><?php echo translate('From URL'); ?>: <input type='text' value='http://' /><input type='button' value='<?php echo translate('Submit'); ?>' id='urlimage_submit' /></p>",
    buttonClick: cmsimage
  };
  // Define the link button
  $.cleditor.buttons.cmslink = {
	name: "cmslink",
	stripIndex: 24,
	title: "<?php echo translate('Insert Link'); ?>",
	command: "inserthtml",
	popupName: "cmslink",
	popupClass: "cleditorPrompt",
	popupContent:
      "<p class='page' style='text-align:left;'><?php echo translate('Page'); ?>: <select>"+getPageOptions()+"</select><input type='button' value='<?php echo translate('Submit'); ?>'/></p>"+
      "<p class='file' style='text-align:left;'><?php echo translate('File'); ?>: <select>"+getFileOptions()+"</select><input type='button' value='<?php echo translate('Submit'); ?>' /></p>"+
	  "<p class='url' style='text-align:left;'><?php echo translate('URL'); ?>: <input type='text' value='http://' /><input type='button' value='<?php echo translate('Submit'); ?>' /></p>"+
	  "<p class='email' style='text-align:left;'><?php echo translate('Email'); ?>: <input type='text' value='' /><input type='button' value='<?php echo translate('Submit'); ?>' /></p>",
	  
	buttonClick: cmslink
  };
  $.cleditor.buttons.cmscontent = {
	name: "cmscontent",
	image: "icons/cms.png",
	title: "<?php echo translate('Insert CMS Element'); ?>",
	command: "inserthtml",
	popupName: "cmscontent",
	popupClass: "cleditorPrompt",
	popupContent:
		"<div style='text-align:left;'><?php echo translate('Page'); ?>: <select>"+getAllPageOptions()+"</select><br/>"+
		"<?php echo translate('Element'); ?>: <select><option>...</option></select><br/>"+
		"<input type='button' value='<?php echo translate('Submit'); ?>' /></div>",
	buttonClick: cmscontent
  };
  $.cleditor.buttons.cmssitevar = {
	name: "cmssitevar",
	image: "icons/cmssitevar.png",
	title: "<?php echo translate('Insert Site Variable'); ?>",
	command: "inserthtml",
	popupName: "cmssitevar",
	popupClass: "cleditorPrompt",
	popupContent:
		"<?php echo translate('Var'); ?>: <select>"+getElementOptions('site_variables')+"</select><br/>"+
		"<input type='button' value='<?php echo translate('Submit'); ?>' /></div>",
	buttonClick: cmssitevar
  };
  
  // Sitevar popup handler
  function cmssitevar(e,data) {
	$(":button",$(data.popup)).unbind('click').bind('click',function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the element name
        var $text = $('select',$(data.popup)).val();

        // Build the html
        var html = "<span class='cms_value sitevar'>"+$text+"</span>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
	});
  }
  // CMS popup handler
  function cmscontent(e,data) {
	//populate element list on change
	$("select:first",$(data.popup)).unbind('change').bind('change', function(e) {
		var temp = getElementOptions($("select:first",$(data.popup)).val());
		$("select:last",$(data.popup)).html(temp);
	}).trigger('change');
	
	$(":button",$(data.popup)).unbind('click').bind('click',function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the page name and element name
        var $text = $('select:first',$(data.popup)).val();
		var $text2 = $('select:last',$(data.popup)).val();

        // Build the html
        var html = "<span class='cms_value cms'>"+$text+" - "+$text2+"</span>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
	});
  }
  
  // Link popup handler
  function cmslink(e,data) {
    //Page link
    $(".page :button",$(data.popup)).unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the page name
        var $text = $('.page select',$(data.popup)).val();
		var $display = editor.selectedHTML();
		if($display.length < 1) $display = $text;

        // Build the html
        var html = "<a href='"+site.site_root+$text+"'>"+$display+"</a>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
    });
    //File link
    $(".file :button",$(data.popup)).unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the file name
        var $text = $('.file select',$(data.popup)).val();
		var $display = editor.selectedHTML();
		if($display.length < 1) $display = $text;

        // Build the html
        var html = "<a href='"+site.site_root+'files/'+$text+"'>"+$display+"</a>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
    });
    //URL link
    $(".url :button",$(data.popup)).unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the url
        var $text = $('.url :text',$(data.popup)).val();
		var $display = editor.selectedHTML();
		if($display.length < 1) $display = $text;

        // Build the html
        var html = "<a href='"+$text+"'>"+$display+"</a>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
    });
    //Email link
    $(".email :button",$(data.popup)).unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the url
        var $text = $('.email :text',$(data.popup)).val();
		var $display = editor.selectedHTML();
		if($display.length < 1) $display = $text;

        // Build the html
        var html = "<a href='mailto:"+$text+"'>"+$display+"</a>";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
        editor.hidePopups();
        editor.focus();
    });
  }
  
  // Image popup handler
  function cmsimage(e,data) {
    //Uploaded image submit
    $("#cmsimage_submit").unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the image file
        var $text = $(data.popup).find("select:first").val();

        // Build the html
        var html = "<img src='"+site.site_root+"uploadedimages/"+$text+"' class='cms_image' />";
		
        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
		$(data.popup).find(":text:first").val('http://');
        editor.hidePopups();
        editor.focus();
    });
    //URL image submit
    $("#urlimage_submit").unbind("click").bind("click", function(e) {
        // Get the editor
        var editor = data.editor;

        // Get the image url
        var $text = $(data.popup).find(":text:first").val();

        // Build the html
        var html = "<img src='"+$text+"' />";

        // Insert the html
        if (html)
          editor.execCommand(data.command, html, null, data.button);

        // Reset the text, hide the popup and set focus
		$(data.popup).find(":text:first").val('http://');
        editor.hidePopups();
        editor.focus();
    });
	
  }

})(jQuery);
function getPageOptions() {
	return "<?php
		$temp = glob(SITE_FOLDER.'cms/pages/*.php');
		foreach($temp as $name) {
			$name = basename($name,'.php');
			if(in_array($name,array('header','footer','site_variables','style_sheets','page_not_found'))) continue;
			echo "<option value='$name/'>$name</option>";
		}
	?>";
}
function getImageOptions() {
	return "<?php
		$temp = glob('uploadedimages/*.*');
		foreach($temp as $name) {
			if(is_dir($name)) continue;
			$name = basename($name);

			echo "<option value='$name'>$name</option>";
		}
	?>";
}
function getFileOptions() {
	return "<?php
		$temp = glob('files/*.*');
		foreach($temp as $name) {
			if(is_dir($name)) continue;
			$name = basename($name);

			echo "<option value='$name'>$name</option>";
		}
	?>";
}
function getAllPageOptions() {
	return "<?php
		$temp = glob(SITE_FOLDER.'cms/pages/*.php');
		foreach($temp as $name) {
			$name = basename($name,'.php');
			if($name == 'style_sheets') continue;
			echo "<option value='$name'>$name</option>";
		}
	?>";
}
function getElementOptions(page) {
	var elements = <?php
		$temp = glob(SITE_FOLDER.'cms/pages/*.php');
		$temp[] = 'site_variables.php';
		$temp = array_unique($temp);
		$temp2 = array();
		foreach($temp as $name) {
			$name = basename($name,'.php');
			if(in_array($name,array('style_sheets'))) continue;
			$temp3 = array();
			$temp4 = glob(SITE_FOLDER.'cms/page_content/'.$name.'/*.php');
			foreach($temp4 as $name2) {
				$name2 = basename($name2,'.php');
				if($name=='site_variables' && $name2=='users') continue;
				$temp3[] = "<option value='$name2'>$name2</option>";
			}
			$temp2[$name] = implode('',$temp3);
		}
		echo json_encode($temp2);
	?>;
	return elements[page];
}

<?php } ?>
</script>
<h2><?php echo translate('Editing'); ?> <?php echo $page_select; ?> &gt; <?php echo $element_select; ?></h2>
<br/>
<p class='preview_links'>
	<a href='#' target='_blank' id='preview_page'><?php echo translate('Preview '.($edit_element? 'element' : 'page')); ?></a>
	<?php if($edit_element) { ?>
	<a href='<?php echo $site_root; ?>cms/edit_page/<?php echo $page; ?>/'><?php echo translate('Edit Page'); ?></a>
	<?php } else { ?>
	<a href='<?php echo $site_root; ?>cms/edit/<?php echo $page; ?>/'><?php echo translate('Choose Element'); ?></a>
	<?php } ?>
	<a href='<?php echo $site_root; ?>cms/edit/<?php echo ($edit_element? $page.'/' : ''); ?>'><?php echo translate('Choose Different '.($edit_element? 'Element' : 'Page')); ?></a>
	<a href='<?php echo $site_root; ?>cms/delete_<?php echo ($edit_element? 'element' : 'page'); ?>/?page=<?php echo $page; ?>&element=<?php echo $element; ?>' style='color:red;'><?php echo translate('Delete '.($edit_element? 'Element' : 'Page')); ?></a>
	
</p>
<?php if($description) { ?>
<div style='float:right; width: 250px;'>
	<h3 class='ui-widget-header'><?php echo translate('Description'); ?> 
	<?php if(!$_REQUEST['edit_description']) { ?>
	<a style='float:right;' href='?edit_description=true'><?php echo (translate('edit')); ?></a>
	<?php } ?></h3>
	<div class='ui-widget-content'>
		<?php echo $description; ?>
	</div>
</div>
<?php } ?>
<div <?php if($description) { ?>style='margin-right: 270px; width: 630px;'<?php } ?>>
	<form method="post" class='ui-helper-reset' action="<?php echo $site_root.$current_path.'?'.$_SERVER['QUERY_STRING']; ?>" style='width: 100%; '><div>
	<?php
	if($updated) echo "<div id='update_notice'>".notice(translate('Page successfully updated'))."</div>";
	echo "<div id='needs_updating' style='display:none;'>".alert(translate('You have unsaved changes.  Click the \"Save Changes\" button below or')." <a href='?'>".translate('undo')."</a>.")."</div>";
	?>
	<div id='dsrte_holder'>
	<?php
	if($markitup) {
	?>
		<textarea name='dsrte_text' id='dsrte_text'><?php echo $content; ?></textarea>
		<script type='text/javascript'>
			$("#dsrte_text").markItUp(markitup_settings);
		</script>
	<?php
	}
	else { 
	?>
		<textarea name='dsrte_text' id='dsrte_text' style='width:100%; height:100px;' ><?php echo $content; ?></textarea>
	<?php 
	}
	?>
	</div>
	<?php
	if($plugin_code) {
		echo $plugin_code;
	}
	?>
		<br />
		<input type='submit' value='<?php echo translate('Save Changes'); ?>' name='submit' class='ui-state-default ui-button ui-corner-all' />
		<a style='margin-left: 10px; display:inline-block;' href='<?php echo $site_root."cms/edit/$page/"; ?>'><?php echo translate('Cancel'); ?></a>
		<?php if(($edit_element && glob(SITE_FOLDER."cms/revisions/$page/$element/*.r")) || (glob(SITE_FOLDER."cms/revisions/$page/*.r"))) { ?>
		<a style='margin-left: 10px; display:inline-block;' href='<?php echo $site_root."cms/revisions/?page=$page&element=$element"; ?>'><?php echo translate('See revisions'); ?></a>
		<?php } ?>
	</div></form>
</div>

<div id='preview_holder'>
	<a href='#' id='preview_close'><?php echo translate('close'); ?></a><br/>
	<iframe id='preview_target' name='preview_target'></iframe>
</div>

<?php
footer();
?>