<?php
cmsLogin();

$filename = urldecode($_REQUEST['name']);
$newname = urldecode($_REQUEST['new_name']);

$dir = rtrim(dirname($filename),'/').'/';

$temp = explode('/',$filename);
$temp = array_shift($temp);
$file = $filename;

if($temp !== 'uploadedimages' && $temp !== 'files') {
	$file = 'files/'.$file;
}
elseif(empty($file) || !file_exists($file)) {
	exit(Widget::generateResponse(array(
		'error'=>translate('The file cannot be found')
	)));
}
//rename file
elseif(($_REQUEST['submit'] || $_REQUEST['confirm']) && !empty($newname) && (!file_exists($dir.$newname) || $_REQUEST['overwrite'])) {
	//newname doesn't have same extension
	$ext = pathinfo($file, PATHINFO_EXTENSION);
	if(!empty($ext) && $ext !== pathinfo($newname, PATHINFO_EXTENSION)) {
		$newname .= '.' . $ext;
	}

	if(!rename($file,$dir.$newname)) {
		exit(Widget::generateResponse(array(
			'error'=>translate('There was an error renaming the file')
		)));
	}
	
	//loop through all pages to update references
	$errors = array();
	$references = array('pages'=>array(),'elements'=>array(),'page_revisions'=>array(),'element_revisions'=>array());
	$f = preg_replace(array('/^uploadedimages\/|^files\//','/\//'),array('','\/'),$filename);
	$pages = glob(SITE_FOLDER."cms/pages/*.php");
	
	if(!empty($ext)) {
		foreach($pages as $p) {
			$p = basename($p,'.php');
			
			//replace references in page itself
			$pcontent = file_get_contents(SITE_FOLDER."cms/pages/$p.php");
			$pcontent2 = preg_replace("/$f/","$newname",$pcontent);
			
			if($pcontent2 !== $pcontent) {
				file_put_contents(SITE_FOLDER."cms/pages/$p.php",$pcontent2);
				$references['pages'][] = $p;
			}
			
			//loop through page revisions
			$rev = glob(SITE_FOLDER."cms/revisions/$p/*.r");
			$rev[] = SITE_FOLDER."cms/revisions/$p/current.txt";
			foreach($rev as $r) {
				if(!file_exists($r)) continue;
				$r = basename($r);
				$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$r");
				$rcontent2 = preg_replace("/$f/","$newname",$rcontent2);
			
				if($rcontent2 !== $rcontent) {
					file_put_contents(SITE_FOLDER."cms/revisions/$p/$r",$rcontent2);
					$references['page_revisions'][] = array($p,$r);
				}
			}
			
			//loop through page elements
			$elements = glob(SITE_FOLDER."cms/page_content/$p/*.php");
			foreach($elements as $e) {
				$e = basename($e,'.php');
				
				//replace references in element
				$econtent = file_get_contents(SITE_FOLDER."cms/page_content/$p/$e.php");
				$econtent2 = preg_replace("/$f/","$newname",$econtent);
			
				if($econtent2 !== $econtent) {
					file_put_contents(SITE_FOLDER."cms/page_content/$p/$e.php",$econtent2);
					$references['elements'][] = array($p,$e);
				}
				
				//loop through element revisions
				$rev = glob(SITE_FOLDER."cms/revisions/$p/$e/*.r");
				$rev[] = SITE_FOLDER."cms/revisions/$p/$e/current.txt";
				foreach($rev as $r) {
					if(!file_exists($r)) continue;
					$r = basename($r);
					$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$e/$r");
					$rcontent2 = preg_replace("/$f/","$newname",$rcontent2);
				
					if($rcontent2 !== $rcontent) {
						file_put_contents(SITE_FOLDER."cms/revisions/$p/$e/$r",$rcontent2);
						$references['element_revisions'][] = array($p,$e,$r);
					}
				}
			}
		}
	}
	
	$msg = '';
	if(!empty($references['pages'])) {
		$msg .= "<strong>Pages:</strong><ul>";
		foreach($references['pages'] as $p) {
			$msg .= "<li>$p - <a href='{$site_root}cms/edit_page/$p/'>edit</a></li>";
		}
		$msg .= "</ul>";
	}
	if(!empty($references['elements'])) {
		$msg .= "<strong>Elements:</strong><ul>";
		foreach($references['elements'] as $e) {
			$p = $e[0];
			$e = $e[1];
			
			$msg .= "<li>$p &gt; $e - <a href='{$site_root}cms/edit_page/$p/$e/'>edit</a></li>";
		}
		$msg .= "</ul>";
	}
	
	//references updated
	if($msg) exit(Widget::generateResponse(array(
		'trigger'=>'refresh_fileinfo',
		'header'=>'Rename File',
		'html'=>'<p>The file was renamed and references were updated on the following pages and elements:</p>'.$msg,
		'buttons'=>array(
			'close'=>'close'
		)
	),'reload'));
	//no references updated
	else exit(Widget::generateResponse(array(
		'trigger'=>'refresh_fileinfo'
	),'reload'));
}
//ask to overwrite
elseif(($_REQUEST['submit'] || $_REQUEST['confirm']) && !empty($newname)) {
	//create form html
	ob_start();
?>
	<form action='<?php echo $site_root.$current_path; ?>'>
		<input type='hidden' name='name' value='<?php echo $file; ?>' />
		<input type='hidden' name='new_name' value='<?php echo $newname; ?>' />
		<input type='hidden' name='overwrite' value='true' />
		<p><?php echo translate('There is already a file with that name'); ?>.  <?php echo translate('Do you want to overwrite the existing file'); ?>?</p>
	</form>
<?php
	$html = ob_get_contents();
	ob_end_clean();
	
	//display confirmation dialog
	exit(Widget::generateResponse(array(
		'header'=>translate('Rename File'),
		'html'=>$html,
		'buttons'=>array(
			translate('yes')=>'submit',
			translate('no')=>'close'
		)
	)));
}
else {
	//create form html
	ob_start();
?>
	<form action='<?php echo $site_root.$current_path; ?>'>
		<input type='hidden' name='name' value='<?php echo $file; ?>' />
		<label>Current Name:</label> <strong><?php echo basename($file); ?></strong><br/>
		<label>New Name:</label> <input type='text' name='new_name' />
	</form>
<?php
	$html = ob_get_contents();
	ob_end_clean();
	
	//display confirmation dialog
	exit(Widget::generateResponse(array(
		'header'=>translate('Rename File'),
		'html'=>$html,
		'buttons'=>array(
			translate('rename')=>'submit',
			translate('Cancel')=>'close'
		)
	)));
}
?>