<?php
cmsLogin();

$page = $_REQUEST['page'];
//page is empty
if(empty($page)) {
	header("Location: {$site_root}cms/edit/");
	exit();
}
//page doesn't exist
if(!file_exists(SITE_FOLDER."cms/pages/$page.php")) {
	header("Location: {$site_root}cms/edit/");
	exit();
}
//can't delete page
elseif($acl['nodelete'] || (isset($acl['pages'][$page]) && $acl['pages'][$page] !== 2)) {
	header("Location: {$site_root}cms/edit/$page/");
	exit();
}


//form submitted
if($_REQUEST['submit_rename']) {	

	//make lowercase
	$new = strtolower($_REQUEST['new']);

	//remove characters that aren't allowed
	$new = preg_replace(array('/[\s]+/','/[^a-z0-9\-_]/'),array('_',''),$new);
	
	if(empty($new)) {
		$error_message = alert("Please choose a valid new name.");
	}
	elseif($page===$new) {
		$error_message = alert("Type a new name in the text field.");
	}
	elseif(file_exists(SITE_FOLDER."cms/pages/$new.php")) {
		$error_message = alert("There is already another page with that name.");
	}
	else {
		$errors = array();
		$references = array('pages'=>array(),'elements'=>array(),'page_revisions'=>array(),'element_revisions'=>array());
		
		//rename pages/old.php to pages/new.php
		if(!rename(SITE_FOLDER."cms/pages/$page.php",SITE_FOLDER."cms/pages/$new.php")) {
			$errors[] = "There was an error renaming 'pages/$page.php' to 'pages/$new.php'.";
		}
		
		//rename page_content/old/ to page_content/new/
		if(!rename(SITE_FOLDER."cms/page_content/$page/",SITE_FOLDER."cms/page_content/$new/")) {
			$errors[] = "There was an error renaming 'page_content/$page/' to 'page_content/$new/'.";
		}
		
		//rename page_descriptions/old/ to page_descriptions/new/
		if(!rename(SITE_FOLDER."cms/page_descriptions/$page/",SITE_FOLDER."cms/page_descriptions/$new/")) {
			$errors[] = "There was an error renaming 'page_descriptions/$page/' to 'page_descriptions/$new/'.";
		}
		
		//rename revisions/old/ to revisions/new/
		if(!rename(SITE_FOLDER."cms/revisions/$page/",SITE_FOLDER."cms/revisions/$new/")) {
			$errors[] = "There was an error renaming 'revisions/$page/' to 'revisions/$new/'.";
		}
		
		//loop through all pages
		$pages = glob(SITE_FOLDER."cms/pages/*.php");
		foreach($pages as $p) {
			$p = basename($p,'.php');
			
			//replace references in page itself
			$pcontent = file_get_contents(SITE_FOLDER."cms/pages/$p.php");
			$pcontent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*([^\[]*)\[\/cms\]/','/CMS::load\([\s]*[\'"]'.$page.'[\'"][\s]*,[\s]*[\'"]([^\'"]*)[\'"][\s]*\)/'),array("[cms]$new - $1[/cms]","CMS::load('$new','$1')"),$pcontent);
			
			
			if($pcontent2 !== $pcontent) {
				file_put_contents(SITE_FOLDER."cms/pages/$p.php",$pcontent2);
				$references['pages'][] = $p;
			}
			
			//loop through page revisions
			$rev = glob(SITE_FOLDER."cms/revisions/$p/*.r");
			$rev[] = SITE_FOLDER."cms/revisions/$p/current.txt";
			foreach($rev as $r) {
				if(!file_exists($r)) continue;
				$r = basename($r);
				$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$r");
				$rcontent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*([^\[]*)\[\/cms\]/','/CMS::load\([\s]*[\'"]'.$page.'[\'"][\s]*,[\s]*[\'"]([^\'"]*)[\'"][\s]*\)/'),array("[cms]$new - $1[/cms]","CMS::load('$new','$1')"),$rcontent2);
			
				if($rcontent2 !== $rcontent) {
					file_put_contents(SITE_FOLDER."cms/revisions/$p/$r",$rcontent2);
					$references['page_revisions'][] = array($p,$r);
				}
			}
			
			//loop through page elements
			$elements = glob(SITE_FOLDER."cms/page_content/$p/*.php");
			foreach($elements as $e) {
				$e = basename($e,'.php');
				
				//replace references in element
				$econtent = file_get_contents(SITE_FOLDER."cms/page_content/$p/$e.php");
				$econtent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*([^\[]*)\[\/cms\]/','/"'.$page.'\/"/'),array("[cms]$new - $1[/cms]",'"'.$new.'/"'),$econtent);
			
				if($econtent2 !== $econtent) {
					file_put_contents(SITE_FOLDER."cms/page_content/$p/$e.php",$econtent2);
					$references['elements'][] = array($p,$e);
				}
				
				
				//loop through element revisions
				$rev = glob(SITE_FOLDER."cms/revisions/$p/$e/*.r");
				$rev[] = SITE_FOLDER."cms/revisions/$p/$e/current.txt";
				foreach($rev as $r) {
					if(!file_exists($r)) continue;
					$r = basename($r);
					$rcontent = file_get_contents(SITE_FOLDER."cms/revisions/$p/$e/$r");
					$rcontent2 = preg_replace(array('/\[cms\][\s]*'.$page.'[\s]*-[\s]*([^\[]*)\[\/cms\]/','/"'.$page.'\/"/'),array("[cms]$new - $1[/cms]",'"'.$new.'/"'),$rcontent2);
				
					if($rcontent2 !== $rcontent) {
						file_put_contents(SITE_FOLDER."cms/revisions/$p/$e/$r",$rcontent2);
						$references['element_revisions'][] = array($p,$e,$r);
					}
				}
			}
		}
		
		if($errors) {
			$error_message = alert(implode(".  ",$errors).".  You will have to manually rename these files and folders.");
		}
		else {
			$msg = '';
			if(!empty($references['pages'])) {
				$msg .= "<strong>Pages:</strong><ul>";
				foreach($references['pages'] as $p) {
					$msg .= "<li>$p - <a href='{$site_root}cms/edit_page/$p/'>edit</a></li>";
				}
				$msg .= "</ul>";
			}
			if(!empty($references['elements'])) {
				$msg .= "<strong>Elements:</strong><ul>";
				foreach($references['elements'] as $e) {
					$p = $e[0];
					$e = $e[1];
					
					$msg .= "<li>$p &gt; $e - <a href='{$site_root}cms/edit/$p/$e/'>edit</a></li>";
				}
				$msg .= "</ul>";
			}
			if($msg) {
				$title = translate('Rename Page');
				include_header('cms_header');
				echo notice("The page was successfully renamed");
				?>
				<p>The following references were updated:</p>
				<?php
				echo $msg;
				?>
				<p><a href='<?php echo $site_root; ?>cms/edit/<?php echo $page; ?>/'><?php echo translate('Back To Page'); ?></a></p>
				<?php
				footer();
				exit();
			}
			else {
				header("Location: {$site_root}cms/edit/$new/");
			}
		}
	}
}


$title = translate('Rename Page');
include_header('cms_header');

//needs to choose new name
?>
	<p>This will rename the page and update all references to the page throughout the site.  Updating the references may take some time, so please be patient.</p>
<?php
	if($error_message) echo $error_message;
?>
	<form method='post' action='<?php echo $site_root.$current_path; ?>'>
		<p>Rename page <strong><?php echo $page; ?></strong> to <input type='text' name='new' />
		<input type='hidden' name='page' value='<?php echo $page; ?>' />
		<input type='submit' class='ui-button ui-state-default ui-corner-all' value='Rename' name='submit_rename' />
		<a href='<?php echo $site_root; ?>cms/edit/<?php echo $page; ?>/'>Cancel</a>
	</form>
<?php
footer();
?>