// ----------------------------------------------------------------------------
// markItUp!
// ----------------------------------------------------------------------------
// Copyright (C) 2008 Jay Salvat
// http://markitup.jaysalvat.com/
// ----------------------------------------------------------------------------
// CSS set by Kevin Papst
// http://www.kevinpapst.de/
// Initially written for the BIGACE CMS:
// http://www.bigace.de/
// ----------------------------------------------------------------------------
// Basic CSS set. Feel free to add more tags
// ----------------------------------------------------------------------------
markitup_settings = {
	onEnter:			{},
	onShiftEnter:		{keepDefault:false, placeHolder:'Your comment here', openWith:'\n\/* ', closeWith:' *\/'},
	onCtrlEnter:		{keepDefault:false, placeHolder:"classname", openWith:'\n.', closeWith:' { \n'},
	onTab:				{keepDefault:false, openWith:'  '},
	markupSet:  [	
		{name:'Class', className:'class', key:'N', placeHolder:'Properties here...', openWith:'.[![Class name]!] {\n', closeWith:'\n}'},
		{separator:'---------------' },
		{name:'Bold', className:'bold', key:'B', replaceWith:'font-weight:bold;'},
		{name:'Italic', className:'italic', key:'I', replaceWith:'font-style:italic;'},
		{name:'Stroke through',  className:'stroke', key:'S', replaceWith:'text-decoration:line-through;'},
		{separator:'---------------' },
		{name:'Lowercase', className:'lowercase', key:'L', replaceWith:'text-transform:lowercase;'},
		{name:'Uppercase', className:'uppercase', key:'U', replaceWith:'text-transform:uppercase;'},
		{separator:'---------------' },
		{name:'Text indent', className:'indent', openWith:'text-indent:', placeHolder:'5px', closeWith:';' },
		{name:'Letter spacing', className:'letterspacing', openWith:'letter-spacing:', placeHolder:'5px', closeWith:';' },
		{name:'Line height', className:'lineheight', openWith:'line-height:', placeHolder:'1.5', closeWith:';' },
		{separator:'---------------' },
		{name:'Alignments', className:'alignments', dropMenu:[
			{name:'Left', className:'left', replaceWith:'text-align:left;'},
			{name:'Center', className:'center', replaceWith:'text-align:center;'},
			{name:'Right', className:'right', replaceWith:'text-align:right;'},
			{name:'Justify', className:'justify', replaceWith:'text-align:justify;'}
			]
		},
		{name:'Padding/Margin', className:'padding', dropMenu:[
				{name:'Top', className:'top', openWith:'(!(padding|!|margin)!)-top:', placeHolder:'5px', closeWith:';' },
				{name:'Left', className:'left', openWith:'(!(padding|!|margin)!)-left:', placeHolder:'5px', closeWith:';' },
				{name:'Right', className:'right', openWith:'(!(padding|!|margin)!)-right:', placeHolder:'5px', closeWith:';' },
				{name:'Bottom', className:'bottom', openWith:'(!(padding|!|margin)!)-bottom:', placeHolder:'5px', closeWith:';' }
			]
		},
		{separator:'---------------' },
		{name:'Background Image', className:'background', replaceWith:'background:url([![Source:!:http://]!]) no-repeat 0 0;' },
		{separator:'---------------' },
		
		{name:'Text Color', className:'text-color', dropMenu: genCSSColors('color')},
		{name:'Background Color', className:'background-color', dropMenu: genCSSColors('background-color')}
	]
};

function genCSSColors(property) {
	return [
		{name:'Yellow',	replaceWith:property+':#FCE94F;',	className:"col1-1" },
		{name:'Yellow',	replaceWith:property+':#EDD400;',	className:"col1-2" },
		{name:'Yellow', replaceWith:property+':#C4A000;',	className:"col1-3" },
		
		{name:'Orange', replaceWith:property+':#FCAF3E;',	className:"col2-1" },
		{name:'Orange', replaceWith:property+':#F57900;',	className:"col2-2" },
		{name:'Orange', replaceWith:property+':#CE5C00;',	className:"col2-3" },
		
		{name:'Brown', 	replaceWith:property+':#E9B96E;',	className:"col3-1" },
		{name:'Brown', 	replaceWith:property+':#C17D11;',	className:"col3-2" },
		{name:'Brown',	replaceWith:property+':#8F5902;',	className:"col3-3" },
		
		{name:'Green', 	replaceWith:property+':#8AE234;',	className:"col4-1" },
		{name:'Green', 	replaceWith:property+':#73D216;',	className:"col4-2" },
		{name:'Green',	replaceWith:property+':#4E9A06;',	className:"col4-3" },
		
		{name:'Blue', 	replaceWith:property+':#729FCF;',	className:"col5-1" },
		{name:'Blue', 	replaceWith:property+':#3465A4;',	className:"col5-2" },
		{name:'Blue',	replaceWith:property+':#204A87;',	className:"col5-3" },

		{name:'Purple', replaceWith:property+':#AD7FA8;',	className:"col6-1" },
		{name:'Purple', replaceWith:property+':#75507B;',	className:"col6-2" },
		{name:'Purple',	replaceWith:property+':#5C3566;',	className:"col6-3" },
		
		{name:'Red', 	replaceWith:property+':#EF2929;',	className:"col7-1" },
		{name:'Red', 	replaceWith:property+':#CC0000;',	className:"col7-2" },
		{name:'Red',	replaceWith:property+':#A40000;',	className:"col7-3" },
		
		{name:'Gray', 	replaceWith:property+':#FFFFFF;',	className:"col8-1" },
		{name:'Gray', 	replaceWith:property+':#D3D7CF;',	className:"col8-2" },
		{name:'Gray',	replaceWith:property+':#BABDB6;',	className:"col8-3" },
		
		{name:'Gray', 	replaceWith:property+':#888A85;',	className:"col9-1" },
		{name:'Gray', 	replaceWith:property+':#555753;',	className:"col9-2" },
		{name:'Gray',	replaceWith:property+':#000000;',	className:"col9-3" }
	];
}
